MODULE Datei EXPORTS Main;
(* Autor: Antje Nowack
   Umgebung: PM3, Windows95
   Erstellt: 12. 12. 2000 
   Letzte Aenderung: 12. 12. 2000
*)

IMPORT Rd, IO, SIO, Scan;

TYPE
     Zahlenmenge = SET OF [Mini .. Maxi];

CONST Maxi = 256;
      Mini = -256;

VAR set := Zahlenmenge{};
    dateiName : TEXT; 

(* Die folgende Prozedur produziert zu einer Datei, deren Name eingegeben 
werden muss, die Menge der INTEGER-Zahlen, die in der Datei abgelegt sind. 
Pto Zahl besitzt die Datei eine Zeile. Die Zahlen sind als Text abgelegt. *)

PROCEDURE FileToSet(file_name : TEXT; VAR set :  Zahlenmenge) =
VAR rd : Rd.T;
    t : TEXT;
BEGIN
    (* Oeffnen der Datei mit dem Namen file_name zum Lesen und Setzen eines 
       entsprechenden Eingabestromes. *)
    rd := IO.OpenRead(file_name); 
    set := Zahlenmenge{};
    (* WHILE-Schleife zum zeilenweisen Lesen bis das Ende der Datei erreicht 
       ist. *)
    WHILE NOT Rd.EOF(rd) DO
    (* Lesen von ab der aktuellen Position bis zum naechsten 
       Zeilenvorschubzeichen, also einer Zeile. Das Ergebnis enthaelt nicht
       das Zeilenvorschubzeichen. Das Ergebnis wird t zugewiesen. *)
      t := Rd.GetLine(rd);
    (* Die t entsprechende Zahl wird der Menge hinzugefuegt. *)
      set := set + Zahlenmenge{Scan.Int(t)};
    END;
    (* Schliessen von rd. *)
    Rd.Close(rd);
END FileToSet;

BEGIN
    SIO.PutLine("Bitte geben Sie einen Dateinamen ein:"); 
    dateiName := SIO.GetLine(); 
    FileToSet(dateiName, set);
    (* Hier kann nun etwas eingefuegt werden, z.B. kann weiter mit der
       Menge gearbeitet werden. *)
END Datei.