INTERFACE Automat;

(* Schnittstelle eines Objektmoduls fr einen Getraenkeautomaten.
   Autor           : Moritz Schnizler, RWTH Aachen
   Umgebung        : SRC-Modula-3 rel. 3.6, Windows NT 4.0
   Erstellt        : 21.01.99  Letzte Aenderung: 21.01.99 *)


IMPORT Assertion;


PROCEDURE MuenzeEinwerfen() RAISES {Assertion.Violated};
(* Einwerfen einer Muenze in den Automaten. *)

PROCEDURE GeldZurueck() RAISES {Assertion.Violated};
(* Gibt eine eventuell eingeworfene Muenze zurueck. *)

PROCEDURE Auffuellen() RAISES {Assertion.Violated};
(* Fuelle ein Getraenk in den Automaten ein. *)

PROCEDURE Entnehmen() RAISES {Assertion.Violated};
(* Entnehme bezahltes Getraenk aus dem Automaten. *)

PROCEDURE MuenzeEingeworfen(): BOOLEAN;
(* Prueft, ob Muenze eingeworfen wurde. *)

PROCEDURE Voll(): BOOLEAN;
(* Prueft, ob der Automat voll ist. *)

PROCEDURE Leer(): BOOLEAN;
(* Prueft, ob der Automat leer ist. *)

END Automat.